#include "stdafx.h"
#include "APIWrapper.h"


BOOL CAPIWrapper::checkedSupport_GetUserDefaultLocaleName = FALSE;
BOOL CAPIWrapper::checkedSupport_SHGetStockIconInfo = FALSE;
GetUserDefaultLocaleNameFn* CAPIWrapper::pfnGetUserDefaultLocaleName = NULL;
SHGetStockIconInfoFn* CAPIWrapper::pfnSHGetStockIconInfo = NULL;


CAPIWrapper::CAPIWrapper(void)
{
}


BOOL CAPIWrapper::IsSupported_GetUserDefaultLocaleName(void)
{
	if(!checkedSupport_GetUserDefaultLocaleName) {
		HMODULE hKernel32 = GetModuleHandle(TEXT("kernel32.dll"));
		if(hKernel32) {
			pfnGetUserDefaultLocaleName = reinterpret_cast<GetUserDefaultLocaleNameFn*>(GetProcAddress(hKernel32, "GetUserDefaultLocaleName"));
		}
		checkedSupport_GetUserDefaultLocaleName = TRUE;
	}

	return (pfnGetUserDefaultLocaleName != NULL);
}

BOOL CAPIWrapper::IsSupported_SHGetStockIconInfo(void)
{
	if(!checkedSupport_SHGetStockIconInfo) {
		HMODULE hShell32 = GetModuleHandle(TEXT("shell32.dll"));
		if(hShell32) {
			pfnSHGetStockIconInfo = reinterpret_cast<SHGetStockIconInfoFn*>(GetProcAddress(hShell32, "SHGetStockIconInfo"));
		}
		checkedSupport_SHGetStockIconInfo = TRUE;
	}

	return (pfnSHGetStockIconInfo != NULL);
}

HRESULT CAPIWrapper::GetUserDefaultLocaleName(LPWSTR pBuffer, int bufferSize, int* pReturnValue)
{
	int dummy;
	if(!pReturnValue) {
		pReturnValue = &dummy;
	}

	if(IsSupported_GetUserDefaultLocaleName()) {
		*pReturnValue = pfnGetUserDefaultLocaleName(pBuffer, bufferSize);
		return S_OK;
	} else {
		return E_NOTIMPL;
	}
}
HRESULT CAPIWrapper::SHGetStockIconInfo(SHSTOCKICONID stockIconID, UINT flags, SHSTOCKICONINFO* pStockIconInfo, HRESULT* pReturnValue)
{
	HRESULT dummy;
	if(!pReturnValue) {
		pReturnValue = &dummy;
	}

	if(IsSupported_SHGetStockIconInfo()) {
		*pReturnValue = pfnSHGetStockIconInfo(stockIconID, flags, pStockIconInfo);
		return S_OK;
	} else {
		return E_NOTIMPL;
	}
}