#pragma once


typedef int WINAPI GetUserDefaultLocaleNameFn(__out_ecount(cchLocaleName) LPWSTR lpLocaleName, __in int cchLocaleName);
typedef HRESULT WINAPI SHGetStockIconInfoFn(SHSTOCKICONID siid, UINT uFlags, __inout SHSTOCKICONINFO* psii);

class CAPIWrapper
{
public:
	CAPIWrapper(void);

	static BOOL IsSupported_GetUserDefaultLocaleName(void);
	static BOOL IsSupported_SHGetStockIconInfo(void);
	static HRESULT GetUserDefaultLocaleName(__out_ecount(bufferSize) LPWSTR pBuffer, __in int bufferSize, __deref_out_opt int* pReturnValue);
	static HRESULT SHGetStockIconInfo(SHSTOCKICONID stockIconID, UINT flags, __inout SHSTOCKICONINFO* pStockIconInfo, __deref_out_opt HRESULT* pReturnValue);

protected:
	static BOOL checkedSupport_GetUserDefaultLocaleName;
	static BOOL checkedSupport_SHGetStockIconInfo;
	static GetUserDefaultLocaleNameFn* pfnGetUserDefaultLocaleName;
	static SHGetStockIconInfoFn* pfnSHGetStockIconInfo;
};