#pragma once
#include "afxcmn.h"

#include "common.h"
#include "TaskDialog.h"
#include "DiscFormatData.h"
#include "RecordingController.h"


// CBurnImageDlg dialog

class CBurnImageDlg :
    public CBurnTaskDialog
{
	DECLARE_DYNAMIC(CBurnImageDlg)

public:
	CBurnImageDlg(IGalbaWindow* pGalbaWindow, CWnd* pParent = NULL);   // standard constructor
	virtual ~CBurnImageDlg();

	// Dialog Data
	enum { IDD = IDD_BURNIMAGE_DIALOG };

	BOOL PreTranslateMessage(MSG* pMsg);

	virtual void CancelInterruptibleTask();
	virtual void MediaChanged();

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()

protected:
	void AddSpeedSettingsToComboBox();
	void CheckForBlankMedia();
	IMAPI_MEDIA_PHYSICAL_TYPE GetCurrentMediaType(__in CDiscRecorder* pRecorder);
	void EnableUI(BOOL enable);
	ULONGLONG GetFreeBytesOnMedia(__in CDiscRecorder* pRecorder);
	ULONG	GetMediaTypeSingleSpeed(IMAPI_MEDIA_PHYSICAL_TYPE mediaType);
	LONG GetWriteSpeed();
	void SetCapacity();
	void UpdateBlocksInUse();

	CRecordingController recordingController;
	BOOL alwaysDisableSpeedComboBox;

	struct
	{
		CEdit pathEdit;
		CButton openImageButton;
		CButton closeMediaCheck;
		CButton ejectCheck;
		CComboBox speedCombo;
		CStatic imageSize;
		CProgressCtrl capacityProg;
		CStatic discNotBlank;
		CStatic maxText;
		CButton burnButton;
		CImageList openImageImageList;
		CImageList burnImageList;
	} controls;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnOpenImage();
	afx_msg void OnBurn();

	afx_msg LRESULT OnImapiBeginBurn(WPARAM /*wParam*/, LPARAM /*lParam*/);
	afx_msg LRESULT OnImapiEndBurn(WPARAM wParam, LPARAM /*lParam*/);
	afx_msg LRESULT OnImapiFormatDataUpdate(WPARAM /*wParam*/, LPARAM lParam);
	afx_msg LRESULT OnEjectMedia(WPARAM /*wParam*/, LPARAM /*lParam*/);
};