///////////////////////////////////////////////////////////////////////
// DiscFormatData.h
//
// Wrapper for IDiscFormat2Data interface
#pragma once

#include "common.h"
#include "DiscRecorder.h"


class CDiscFormatData
{
public:
	CDiscFormatData(void);
	~CDiscFormatData(void);

	inline HRESULT GetHresult()
	{
		return lastError;
	}

	inline CString GetErrorMessage()
	{
		return lastErrorMessage;
	}

	inline IDiscFormat2Data* GetInterface()
	{
		return pDF2Data;
	}

	bool Initialize(__in CDiscRecorder* pDiscRecorder, const CString& clientName, HWND hNotificationWnd);
	void SetLastError(HRESULT lastError);
	void SetLastError(HRESULT lastError, CString lastErrorMessage);

	IMAPI_MEDIA_PHYSICAL_TYPE GetCurrentPhysicalMediaType();
	bool IsCurrentMediaSupported(__in CDiscRecorder* pDiscRecorder);
	BOOL IsMediaBlank();
	ULONG GetTotalSupportedMediaTypes();
	IMAPI_MEDIA_PHYSICAL_TYPE GetSupportedMediaType(LONG index);
	ULONG GetTotalSupportedWriteSpeeds();
	ULONG GetSupportedWriteSpeed(LONG index);
	HRESULT SetWriteSpeed(LONG writeSpeed);
	LONG GetFreeSectorsOnMedia();
	LONG GetTotalSectorsOnMedia();
	HRESULT EnableBurnProof(bool enable);
	HRESULT SetCloseMedia(bool closeMedia);

	HRESULT GetMultisessionInterfaces(__out LPSAFEARRAY* ppMultiSession);

protected:
	IDiscFormat2Data*	pDF2Data;
	HRESULT lastError;
	CString lastErrorMessage;
	HWND hNotificationWnd;

private:
	SAFEARRAY* pSupportedMediaTypes;
	SAFEARRAY* pSupportedWriteSpeeds;
};