///////////////////////////////////////////////////////////////////////
// DiscFormatDataEvent.h
//
// Wrapper for DDiscFormat2DataEvents interface events
#pragma once

#include "common.h"


class CDiscFormatData;


// CDiscFormatDataEvent command target
class CDiscFormatDataEvent :
    public CCmdTarget
{
	DECLARE_DYNAMIC(CDiscFormatDataEvent)

public:
	CDiscFormatDataEvent();
	virtual ~CDiscFormatDataEvent();

	static CDiscFormatDataEvent* CreateEventSink();

	bool ConnectDiscFormatData(CDiscFormatData* pDiscFormatData);
	inline void SetNotificationWindow(HWND hWnd)
	{
		hNotificationWnd = hWnd;
	}

	DECLARE_INTERFACE_MAP()

	BEGIN_INTERFACE_PART(FormatDataEvents, DDiscFormat2DataEvents)
		// IDispatch methods
		STDMETHOD(GetTypeInfoCount)(UINT FAR* pctinfo);
		STDMETHOD(GetTypeInfo)(UINT itinfo, LCID /*lcid*/, ITypeInfo FAR* FAR* pptinfo);
		STDMETHOD(GetIDsOfNames)(REFIID /*riid*/, OLECHAR FAR* FAR* rgszNames, UINT cNames, LCID /*lcid*/, DISPID FAR* rgdispid);
		STDMETHOD(Invoke)(DISPID dispidMember, REFIID /*riid*/, LCID /*lcid*/, WORD wFlags, DISPPARAMS FAR* pdispparams, VARIANT FAR* pvarResult, EXCEPINFO FAR* pexcepinfo, UINT FAR* puArgErr);
		// DDiscFormat2DataEvents Methods
		STDMETHOD_(HRESULT, Update)(LPDISPATCH pObjectDispatch, LPDISPATCH pProgressDispatch);
	END_INTERFACE_PART(FormatDataEvents)

protected:
	DECLARE_MESSAGE_MAP()

private:
	LPTYPEINFO pTypeInfo;
	DWORD	cookie;
	LPUNKNOWN	pUnknownSink;
	LPUNKNOWN	pUnknownSource;

	HWND hNotificationWnd;
};