///////////////////////////////////////////////////////////////////////
// DiscFormatErase.h
//
// Wrapper for IDiscFormat2Erase interface
#pragma once

#include "common.h"
#include "DiscRecorder.h"


class CDiscFormatErase
{
public:
	CDiscFormatErase(void);
	~CDiscFormatErase(void);

	inline HRESULT GetHresult()
	{
		return lastError;
	}

	inline CString GetErrorMessage()
	{
		return lastErrorMessage;
	}

	inline IDiscFormat2Erase* GetInterface()
	{
		return pDF2Erase;
	}

	bool Initialize(__in CDiscRecorder* pDiscRecorder, const CString& clientName, HWND hNotificationWnd);
	void SetLastError(HRESULT lastError);
	void SetLastError(HRESULT lastError, CString lastErrorMessage);

	bool IsCurrentMediaSupported(__in CDiscRecorder* pDiscRecorder);
	BOOL IsMediaBlank();
	ULONG GetTotalSupportedMediaTypes();
	IMAPI_MEDIA_PHYSICAL_TYPE GetSupportedMediaType(LONG index);
	HRESULT SetEraseMethod(VARIANT_BOOL fullErase);

protected:
	IDiscFormat2Erase*	pDF2Erase;
	HRESULT lastError;
	CString lastErrorMessage;
	HWND hNotificationWnd;

private:
	SAFEARRAY* pSupportedMediaTypes;
};