///////////////////////////////////////////////////////////////////////
// DiscFormatEraseEvent.cpp
//
// Wrapper for DDiscFormat2EraseEvents interface events

#include "stdafx.h"
#include "DiscFormatEraseEvent.h"
#include "DiscFormatErase.h"


// CDiscFormatEraseEvent

IMPLEMENT_DYNAMIC(CDiscFormatEraseEvent, CCmdTarget)

BEGIN_INTERFACE_MAP(CDiscFormatEraseEvent, CCmdTarget)
	INTERFACE_PART(CDiscFormatEraseEvent, IID_IDispatch, FormatEraseEvents)
	INTERFACE_PART(CDiscFormatEraseEvent, IID_DDiscFormat2EraseEvents, FormatEraseEvents)
END_INTERFACE_MAP()

CDiscFormatEraseEvent::CDiscFormatEraseEvent() :
    hNotificationWnd(NULL),
    pTypeInfo(NULL),
    cookie(0),
    pUnknownSink(NULL),
    pUnknownSource(NULL)
{
}

CDiscFormatEraseEvent::~CDiscFormatEraseEvent()
{
	if(cookie && pUnknownSource && pUnknownSink)
		AfxConnectionUnadvise(pUnknownSource, IID_DDiscFormat2EraseEvents, pUnknownSink, TRUE, cookie);
}


BEGIN_MESSAGE_MAP(CDiscFormatEraseEvent, CCmdTarget)
END_MESSAGE_MAP()


ULONG FAR EXPORT CDiscFormatEraseEvent::XFormatEraseEvents::AddRef()
{
	METHOD_PROLOGUE(CDiscFormatEraseEvent, FormatEraseEvents)
	return pThis->ExternalAddRef();
}

ULONG FAR EXPORT CDiscFormatEraseEvent::XFormatEraseEvents::Release()
{
	METHOD_PROLOGUE(CDiscFormatEraseEvent, FormatEraseEvents)
	return pThis->ExternalRelease();
}

STDMETHODIMP CDiscFormatEraseEvent::XFormatEraseEvents::QueryInterface(REFIID riid, LPVOID FAR* ppvObj)
{
	METHOD_PROLOGUE(CDiscFormatEraseEvent, FormatEraseEvents)
	return pThis->ExternalQueryInterface(&riid, ppvObj);
}

STDMETHODIMP CDiscFormatEraseEvent::XFormatEraseEvents::GetTypeInfoCount(UINT FAR* pctinfo)
{
	METHOD_PROLOGUE(CDiscFormatEraseEvent, FormatEraseEvents)
	*pctinfo = 1;
	return NOERROR;
}

STDMETHODIMP CDiscFormatEraseEvent::XFormatEraseEvents::GetTypeInfo(UINT itinfo, LCID /*lcid*/, ITypeInfo FAR* FAR* pptinfo)
{
	METHOD_PROLOGUE(CDiscFormatEraseEvent, FormatEraseEvents)
	*pptinfo = NULL;

	if(itinfo != 0)
		return ResultFromScode(DISP_E_BADINDEX);
	pThis->pTypeInfo->AddRef();
	*pptinfo = pThis->pTypeInfo;
	return NOERROR;
}

STDMETHODIMP CDiscFormatEraseEvent::XFormatEraseEvents::GetIDsOfNames(REFIID /*riid*/, OLECHAR FAR* FAR* rgszNames, UINT cNames, LCID /*lcid*/, DISPID FAR* rgdispid)
{
	METHOD_PROLOGUE(CDiscFormatEraseEvent, FormatEraseEvents)
	return DispGetIDsOfNames(pThis->pTypeInfo, rgszNames, cNames, rgdispid);
}

STDMETHODIMP CDiscFormatEraseEvent::XFormatEraseEvents::Invoke(DISPID dispidMember, REFIID /*riid*/, LCID /*lcid*/, WORD wFlags, DISPPARAMS FAR* pdispparams, VARIANT FAR* pvarResult, EXCEPINFO FAR* pexcepinfo, UINT FAR* puArgErr)
{
	METHOD_PROLOGUE(CDiscFormatEraseEvent, FormatEraseEvents)
	return DispInvoke(&pThis->m_xFormatEraseEvents, pThis->pTypeInfo, dispidMember, wFlags, pdispparams, pvarResult, pexcepinfo, puArgErr);
}


CDiscFormatEraseEvent* CDiscFormatEraseEvent::CreateEventSink()
{
	CDiscFormatEraseEvent* pDiscFormatEraseEvent = new CDiscFormatEraseEvent();
	pDiscFormatEraseEvent->EnableAutomation();
	pDiscFormatEraseEvent->ExternalAddRef();
	return pDiscFormatEraseEvent;
}

bool CDiscFormatEraseEvent::ConnectDiscFormatErase(CDiscFormatErase* pDiscFormatErase)
{
	pUnknownSink = GetIDispatch(FALSE);
	pUnknownSource = pDiscFormatErase->GetInterface();

	LPTYPELIB pTypeLib = NULL;
	HRESULT hr = LoadRegTypeLib(LIBID_IMAPILib2, IMAPILib2_MajorVersion, IMAPILib2_MinorVersion, LOCALE_SYSTEM_DEFAULT, &pTypeLib);
	if(FAILED(hr))
		return false;
	hr = pTypeLib->GetTypeInfoOfGuid(IID_DDiscFormat2EraseEvents, &pTypeInfo);
	pTypeLib->Release();
	if(FAILED(hr))
		return false;

	BOOL b = AfxConnectionAdvise(pUnknownSource, IID_DDiscFormat2EraseEvents, pUnknownSink, TRUE, &cookie);
	if(b)
		return true;
	return false;
}


STDMETHODIMP_(HRESULT) CDiscFormatEraseEvent::XFormatEraseEvents::Update(LPDISPATCH /*pObjectDispatch*/, LONG elapsedSeconds, LONG estimatedTotalSeconds)
{
	METHOD_PROLOGUE(CDiscFormatEraseEvent, FormatEraseEvents)

	IMAPI_FORMAT_ERASE_UPDATE_EVENT_ARGS eventArgs;
	ZeroMemory(&eventArgs, sizeof(eventArgs));
	eventArgs.elapsedTime = elapsedSeconds;
	eventArgs.totalTime = estimatedTotalSeconds;

	SendMessage(pThis->hNotificationWnd, WM_IMAPI_FORMAT_ERASE_UPDATE, 0, reinterpret_cast<LPARAM>(&eventArgs));
	return S_OK;
}