///////////////////////////////////////////////////////////////////////
// DiscFormatEraseEvent.h
//
// Wrapper for DDiscFormat2EraseEvents interface events
#pragma once

#include "common.h"


class CDiscFormatErase;


// CDiscFormatEraseEvent command target
class CDiscFormatEraseEvent :
    public CCmdTarget
{
	DECLARE_DYNAMIC(CDiscFormatEraseEvent)

public:
	CDiscFormatEraseEvent();
	virtual ~CDiscFormatEraseEvent();

	static CDiscFormatEraseEvent* CreateEventSink();

	bool ConnectDiscFormatErase(CDiscFormatErase* pDiscFormatErase);
	inline void SetNotificationWindow(HWND hWnd)
	{
		hNotificationWnd = hWnd;
	}

	DECLARE_INTERFACE_MAP()

	BEGIN_INTERFACE_PART(FormatEraseEvents, DDiscFormat2EraseEvents)
		// IDispatch methods
		STDMETHOD(GetTypeInfoCount)(UINT FAR* pctinfo);
		STDMETHOD(GetTypeInfo)(UINT itinfo, LCID /*lcid*/, ITypeInfo FAR* FAR* pptinfo);
		STDMETHOD(GetIDsOfNames)(REFIID /*riid*/, OLECHAR FAR* FAR* rgszNames, UINT cNames, LCID /*lcid*/, DISPID FAR* rgdispid);
		STDMETHOD(Invoke)(DISPID dispidMember, REFIID /*riid*/, LCID /*lcid*/, WORD wFlags, DISPPARAMS FAR* pdispparams, VARIANT FAR* pvarResult, EXCEPINFO FAR* pexcepinfo, UINT FAR* puArgErr);
		// DDiscFormat2EraseEvents Methods
		STDMETHOD_(HRESULT, Update)(LPDISPATCH /*pObjectDispatch*/, LONG elapsedSeconds, LONG estimatedTotalSeconds);
	END_INTERFACE_PART(FormatEraseEvents)

protected:
	DECLARE_MESSAGE_MAP()

private:
	LPTYPEINFO pTypeInfo;
	DWORD	cookie;
	LPUNKNOWN	pUnknownSink;
	LPUNKNOWN	pUnknownSource;

	HWND hNotificationWnd;
};