///////////////////////////////////////////////////////////////////////
// DiscRecorder.h
//
// Wrapper for IDiscRecorder2 interface
#pragma once

#include "common.h"


class CDiscRecorder
{
public:
	CDiscRecorder(void);
	~CDiscRecorder(void);

	inline HRESULT GetHresult()
	{
		return lastError;
	}

	inline CString GetErrorMessage()
	{
		return lastErrorMessage;
	}

	inline IDiscRecorder2* GetInterface()
	{
		return pDiscRecorder;
	}

	inline CString GetUniqueId()
	{
		return uniqueID;
	}

	bool Initialize(const CString& recorderUniqueID);
	void SetLastError(HRESULT lastError);
	void SetLastError(HRESULT lastError, CString lastErrorMessage);

	LONG GetLegacyDeviceNumber();
	CString GetProductID();
	CString GetProductRevision();
	CString GetVendorID();
	CString GetVolumeName();
	ULONG GetTotalVolumePaths();
	CString GetVolumePath(LONG index);

	bool AcquireExclusiveAccess(bool force, const CString& clientName);	
	bool ReleaseExclusiveAccess();
	CString GetExclusiveAccessOwner();
	bool EjectMedia();
	bool CloseTray();
	bool EnableMcn();
	bool DisableMcn();

private:
	IDiscRecorder2*	pDiscRecorder;
	HRESULT lastError;
	CString lastErrorMessage;
	CString uniqueID;

private:
	SAFEARRAY* pVolumePathNames;
};