#pragma once
#include "afxcmn.h"

#include "common.h"
#include "TaskDialog.h"
#include "DiscFormatData.h"
#include "DiscFormatErase.h"
#include "ErasingController.h"


// CEraseDiscDlg dialog

class CEraseDiscDlg :
    public CBurnTaskDialog
{
	DECLARE_DYNAMIC(CEraseDiscDlg)

public:
	CEraseDiscDlg(IGalbaWindow* pGalbaWindow, CWnd* pParent = NULL);   // standard constructor
	virtual ~CEraseDiscDlg();

	// Dialog Data
	enum { IDD = IDD_ERASEDISC_DIALOG };

	BOOL PreTranslateMessage(MSG* pMsg);

	virtual void CancelInterruptibleTask();
	virtual void MediaChanged();

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()

protected:
	void CheckForMedia();
	IMAPI_MEDIA_PHYSICAL_TYPE GetCurrentMediaType(__in CDiscRecorder* pRecorder);
	void EnableUI(BOOL enable);
	LONGLONG GetTotalBytesOnMedia(__in CDiscRecorder* pRecorder);
	void SetCapacity();
	void UpdateBlocksInUse();

	CErasingController erasingController;

	struct
	{
		CComboBox eraseMethodCombo;
		CButton ejectCheck;
		CProgressCtrl capacityProg;
		CStatic noMedia;
		CStatic maxText;
		CButton eraseButton;
		CImageList eraseImageList;
	} controls;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnErase();

	afx_msg LRESULT OnImapiBeginErase(WPARAM /*wParam*/, LPARAM /*lParam*/);
	afx_msg LRESULT OnImapiEndErase(WPARAM wParam, LPARAM /*lParam*/);
	afx_msg LRESULT OnImapiFormatEraseUpdate(WPARAM /*wParam*/, LPARAM lParam);
};