#pragma once

#include "common.h"
#include "DiscRecorder.h"
#include "DiscFormatErase.h"


class CErasingController
{
public:
	CErasingController(void);
	~CErasingController(void);

	inline HRESULT GetHresult()
	{
		CSingleLock singleLock(&criticalSection);
		return lastError;
	}

	inline CString GetErrorMessage()
	{
		CSingleLock singleLock(&criticalSection);
		return lastErrorMessage;
	}

	inline void SetRecorderID(CString discRecorderID)
	{
		this->recorderID = discRecorderID;
	}

	inline void SetClientName(const CString& clientName)
	{
		this->clientName = clientName;
	}

	inline void SetNotificationWindow(HWND hNotificationWnd)
	{
		this->hNotificationWnd = hNotificationWnd;
	}

	inline void SetEraseMethod(VARIANT_BOOL fullErase)
	{
		this->fullErase = fullErase;
	}

	inline void SetEjectMedia(bool ejectMedia)
	{
		this->ejectMedia = ejectMedia;
	}

	bool GetCancelFlag();
	void SetCancelFlag(bool cancel);
	void SetLastError(HRESULT lastError);
	void SetLastError(HRESULT lastError, CString lastErrorMessage);

	bool Erase();
	static UINT __cdecl EraseThread(LPVOID pParam);

protected:
	CWinThread* pWorkerThread;
	CCriticalSection criticalSection;
	HRESULT lastError;
	CString lastErrorMessage;
	bool cancel;

	CString recorderID;
	CString clientName;
	HWND hNotificationWnd;
	VARIANT_BOOL fullErase;
	bool ejectMedia;
};

typedef struct THREAD_PARAMS_ERASE
{
	CErasingController* pThis;
	CString recorderID;
	CString clientName;
	HWND hNotificationWnd;
	VARIANT_BOOL fullErase;
	bool ejectMedia;
} THREAD_PARAMS_ERASE, *PTHREAD_PARAMS_ERASE;