///////////////////////////////////////////////////////////////////////
// FileSystemImageEvent.h
//
// Wrapper for DFileSystemImageEvents interface events
#pragma once

#include "common.h"


class CFileSystemImage;

// CFileSystemImageEvent command target
class CFileSystemImageEvent :
    public CCmdTarget
{
	DECLARE_DYNAMIC(CFileSystemImageEvent)

public:
	CFileSystemImageEvent();
	virtual ~CFileSystemImageEvent();

	static CFileSystemImageEvent* CreateEventSink();

	bool ConnectFileSystemImage(CFileSystemImage* pFileSystemImage);
	inline void SetNotificationWindow(HWND hWnd)
	{
		hNotificationWnd = hWnd;
	}
	inline void SetCurrentFile(CString file)
	{
		currentFile = file;
	}

	DECLARE_INTERFACE_MAP()

	BEGIN_INTERFACE_PART(FileSystemImageEvents, DFileSystemImageEvents)
		// IDispatch methods
		STDMETHOD(GetTypeInfoCount)(UINT FAR* pctinfo);
		STDMETHOD(GetTypeInfo)(UINT itinfo, LCID /*lcid*/, ITypeInfo FAR* FAR* pptinfo);
		STDMETHOD(GetIDsOfNames)(REFIID /*riid*/, OLECHAR FAR* FAR* rgszNames, UINT cNames, LCID /*lcid*/, DISPID FAR* rgdispid);
		STDMETHOD(Invoke)(DISPID dispidMember, REFIID /*riid*/, LCID /*lcid*/, WORD wFlags, DISPPARAMS FAR* pdispparams, VARIANT FAR* pvarResult, EXCEPINFO FAR* pexcepinfo, UINT FAR* puArgErr);
		// DFileSystemImageEvents Methods
		STDMETHOD_(HRESULT, Update)(LPDISPATCH pObjectDispatch, BSTR currentFile, LONG copiedSectors, LONG totalSectors);
	END_INTERFACE_PART(FileSystemImageEvents)

protected:
	DECLARE_MESSAGE_MAP()

private:
	LPTYPEINFO pTypeInfo;
	DWORD	cookie;
	LPUNKNOWN	pUnknownSink;
	LPUNKNOWN	pUnknownSource;

	HWND hNotificationWnd;
	CString currentFile;
};