// MyDropTarget.cpp : implementation file
//

#include "stdafx.h"
#include "Galba.h"
#include "MyDropTarget.h"
#include "MainDlg.h"


// CMyDropTarget


CMyDropTarget::CMyDropTarget(CMainDlg* pParentDlg) :
    pDropTargetHelper(NULL)
{
	this->pParentDlg = pParentDlg;
}

CMyDropTarget::~CMyDropTarget()
{
}


BEGIN_MESSAGE_MAP(CMyDropTarget, COleDropTarget)
END_MESSAGE_MAP()



// CMyDropTarget message handlers

DROPEFFECT CMyDropTarget::OnDragEnter(CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point)
{
	CoCreateInstance(CLSID_DragDropHelper, NULL, CLSCTX_ALL, IID_PPV_ARGS(&pDropTargetHelper));

	DROPEFFECT effect = DROPEFFECT_NONE;
	if(pDataObject->GetGlobalData(CF_HDROP))
		effect = pParentDlg->OnFileDragOver(pDataObject, dwKeyState, point);

	if(pDropTargetHelper)
		pDropTargetHelper->DragEnter(pWnd->GetSafeHwnd(), pDataObject->GetIDataObject(FALSE), &point, effect);
	return effect;
}

void CMyDropTarget::OnDragLeave(CWnd* /*pWnd*/)
{
	pParentDlg->OnDragLeave();
	if(pDropTargetHelper) {
		pDropTargetHelper->DragLeave();
		pDropTargetHelper->Release();
		pDropTargetHelper = NULL;
	}
}

DROPEFFECT CMyDropTarget::OnDragOver(CWnd* /*pWnd*/, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point)
{
	DROPEFFECT effect = DROPEFFECT_NONE;
	if(pDataObject->GetGlobalData(CF_HDROP))
		effect = pParentDlg->OnFileDragOver(pDataObject, dwKeyState, point);

	if(pDropTargetHelper)
		pDropTargetHelper->DragOver(&point, effect);
	return effect;
}

BOOL CMyDropTarget::OnDrop(CWnd* /*pWnd*/, COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point)
{
	BOOL dropped = FALSE;
	if(pDataObject->GetGlobalData(CF_HDROP))
		dropped = pParentDlg->OnFileDrop(pDataObject, dropEffect, point);

	if(pDropTargetHelper) {
		pDropTargetHelper->Drop(pDataObject->GetIDataObject(FALSE), &point, dropEffect);
		pDropTargetHelper->Release();
		pDropTargetHelper = NULL;
	}
	return dropped;
}