#include "stdafx.h"
#include "APIWrapper.h"
#include "Galba.h"
#include "NewDirectoryDlg.h"


// CNewDirectoryDlg dialog

IMPLEMENT_DYNAMIC(CNewDirectoryDlg, CDialog)

CNewDirectoryDlg::CNewDirectoryDlg(CWnd* pParent/* = NULL*/) :
    CDialog(CNewDirectoryDlg::IDD, pParent)
{
	if(CAPIWrapper::IsSupported_SHGetStockIconInfo()) {
		SHSTOCKICONINFO sii = {0};
		sii.cbSize = sizeof(sii);
		CAPIWrapper::SHGetStockIconInfo(SIID_FOLDER, SHGSI_ICON | SHGSI_SMALLICON, &sii, NULL);
		hIcon = sii.hIcon;
	} else {
		SHFILEINFO shfi = {0};
		SHGetFileInfo(TEXT("folder"), FILE_ATTRIBUTE_DIRECTORY, &shfi, sizeof(SHFILEINFO), SHGFI_ICON | SHGFI_SMALLICON | SHGFI_USEFILEATTRIBUTES);
		hIcon = shfi.hIcon;
	}
}

CNewDirectoryDlg::~CNewDirectoryDlg()
{
	if(hIcon)
		DestroyIcon(hIcon);
}

void CNewDirectoryDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_NAME_EDIT, controls.nameEdit);
	DDX_Control(pDX, IDOK, controls.okButton);
}


BEGIN_MESSAGE_MAP(CNewDirectoryDlg, CDialog)
	ON_EN_CHANGE(IDC_NAME_EDIT, &CNewDirectoryDlg::OnEnChangeNameEdit)
END_MESSAGE_MAP()


CString CNewDirectoryDlg::GetName()
{
	return name;
}


// CNewDirectoryDlg message handlers

BOOL CNewDirectoryDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CString s;
	s.LoadString(IDS_NEW_DIRECTORY);
	controls.nameEdit.SetWindowText(s);

	SetIcon(hIcon, TRUE);
	SetIcon(hIcon, FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
}

void CNewDirectoryDlg::OnOK()
{
	controls.nameEdit.GetWindowText(name);
	CDialog::OnOK();
}

void CNewDirectoryDlg::OnEnChangeNameEdit()
{
	controls.okButton.EnableWindow(controls.nameEdit.GetWindowTextLength() > 0);
}