#pragma once

#define CLIENT_NAME										TEXT("Galba, Successor of Nero")
#define CDROM_EXCLUSIVE_CALLER_LENGTH	64
#define IMAGE_RECORDER_ID							TEXT("Image Recorder")
#define NAMED_PIPE_NAME								TEXT("\\\\.\\pipe\\GalbaControl")

#define DATATYPE_FILE									1
#define DATATYPE_TREE									2
#define DATATYPE_MIXED								(DATATYPE_FILE | DATATYPE_TREE)

#define RETURN_CONTINUE_WRITE					0
#define RETURN_CANCEL_WRITE						1

#define WM_UPDATE_BLOCKS_IN_USE				WM_APP
#define WM_DEVICE_CHANGE							WM_APP
#define WM_EJECT_MEDIA								(WM_APP + 1)
// lParam can be DATATYPE_FILE or DATATYPE_TREE
#define WM_IMAPI_BEGIN_ADD_DATA				(WM_APP + 2)
// wParam can be S_OK (all data has been added successfully), S_FALSE (user canceled) or any other HRESULT value
// lParam can be DATATYPE_FILE or DATATYPE_TREE
#define WM_IMAPI_END_ADD_DATA					(WM_APP + 3)
#define WM_IMAPI_IMAGE_UPDATE					(WM_APP + 4)
#define WM_IMAPI_BEGIN_BURN						(WM_APP + 5)
#define WM_IMAPI_END_BURN							(WM_APP + 6)
#define WM_IMAPI_FORMAT_DATA_UPDATE		(WM_APP + 7)
#define WM_IMAPI_BEGIN_ERASE					(WM_APP + 5)
#define WM_IMAPI_END_ERASE						(WM_APP + 6)
#define WM_IMAPI_FORMAT_ERASE_UPDATE	(WM_APP + 7)
#define WM_PIPE_SERVER_INITIALIZED		(WM_APP + 8)
#define WM_UPDATE_COMPILATION_VIEW		(WM_APP + 9)


typedef struct IMAPI_IMAGE_UPDATE_EVENT_ARGS
{
	CString currentFile;
	LONG copiedSectors;
	LONG totalSectors;
} IMAPI_IMAGE_UPDATE_EVENT_ARGS, *PIMAPI_IMAGE_UPDATE_EVENT_ARGS;

typedef struct IMAPI_FORMAT_DATA_UPDATE_EVENT_ARGS
{
	IMAPI_FORMAT2_DATA_WRITE_ACTION currentAction;
	LONG elapsedTime;
	LONG remainingTime;
	LONG totalTime;
	LONG startLba;
	LONG sectorCount;
	LONG lastReadLba;
	LONG lastWrittenLba;
	LONG totalSystemBuffer;
	LONG usedSystemBuffer;
	LONG freeSystemBuffer;
} IMAPI_FORMAT_DATA_UPDATE_EVENT_ARGS, *PIMAPI_FORMAT_DATA_UPDATE_EVENT_ARGS;

typedef struct IMAPI_FORMAT_ERASE_UPDATE_EVENT_ARGS
{
	LONG elapsedTime;
	LONG totalTime;
} IMAPI_FORMAT_ERASE_UPDATE_EVENT_ARGS, *PIMAPI_FORMAT_ERASE_UPDATE_EVENT_ARGS;


bool IsVistaOrNewer();